* HP-48
*
* M2H - Matrix to hxs nibble stream
*
* This utility converts a real matrix to a flat stream
* Output will be a HXS string, which consists of a header
* Element width in nibs	(1 nib)
* row count		(2 nibs)
* column count		(2 nibs)
*
* After the header the matrix values will be stored in compressed form.
* Values will be stored in hexadecimal form, so 15d will be stored as F
* if #w=1, or 00F if w=3 , for example
*
ASSEMBLE
=ARRYLP_DO    EQU  #37BCB
=PULLEL[S]    EQU  #3558E
=make_hxs     EQU  #0EDE1
=WIPEOUT      EQU  #0675C
RPL

* ( [] #w --> HXS )

::  CK2
    DUPTYPEREAL? IT %ABSCOERCE
    DUPTYPEBINT? NcaseTYPEERR
    SWAP
    DUPTYPEARRY? NcaseTYPEERR		( *# []* )
    SWAPOVER MDIMS ?SKIP ONESWAP	( *This indicates one-dimensional array =vector* )



*Here: [] #w #r #c


*
* wrc2HXS	Create tempob HXS string from #width #rows #cols
*
*	#w #r# #c  -->	HXS|$
*
CODE
*				A	B	C	D	Dn	Rn
	GOSBVL	=POP2#		r		c
	RSTK=C
	GOSBVL	=SAVPTR
	C=RSTK					...cc
	B=A	A			r
	D=C	A					c
	CSL	A		r	r	..cc.	c
	CSL	A				.cc..
	C=C+A	A				.ccrr
	CSL	A				ccrr.
	A=DAT1	A						1:@dsktop
	D1=A							1:@ob1
	D1=D1+	5
	A=DAT1	A		w
	C=C+A	A				ccrrw
	RSTK=C			w	r	ccrrw	c	* Save for later
	C=B	A		w	r	r	c
	GOSBVL	=MUL#		?	prod_wr	?	c
	A=B	A		prod_wr	prod_wr
	C=D	A		prod_wr		c
	GOSBVL	=MUL#			prod_wrc
	C=B	A				prod_wrc
	C=C+CON	A,5
	GOSBVL	=MAKE$N		lenfield			0:@data	0:@prlg
	C=RSTK					ccrrw
	DAT0=C	A						* Write wrc field
*	LC(5)	=DOHSTR

	D0=D0+	5						0:data+5
	AD0EX			@data+5				0:len
	D0=D0-	10						0:len-10
	C=A	A				@data+5
	CD1EX					len-10		1:@data+5
	CD0EX
	GOSBVL	=WIPEOUT
	GOVLNG	=GPOverWrR0Lp
ENDCODE



************************************


	SWAP				( *hxs_rcw' []* )

	ARRYLP_DO (DO)
	    INDEX@ PULLEL[S]

	    COERCE		( *hxs_rcw' [] #* )
	    INDEX@				( *hxs_rcw' [] # #i* )

*			A	B	C	D
CODE
	GOSBVL	=POP2#	#		i
	R3=A
	RSTK=C
	GOSBVL	=SAVPTR
	D1=D1+	5			* Caveat: Stack level 2 !
	GOSBVL	=GetStrLenStk
	C=0	A
	C=DAT1	1			#w
	D1=D1+	5
	A=C	A
	D=C	A
	C=RSTK
	C=C-1	A	#w		i-1	#w
	GOSBVL	=MUL#		product		#w
	CD1EX
	C=C+B	A
	CD1EX
	A=R3
	C=D	A
	P=C	0
	P=P-1
	DAT1=A	WP
	P=	0
	GOVLNG	=GETPTRLOOP
ENDCODE

	LOOP

	DROP






;

